/* Receiver code for the Skateboard Radio control with PWM output
 
  Module // Arduino UNO,NANO 
    GND    ->   GND
    Vcc    ->   3.3V
    CE     ->   D9
    CSN    ->   D10
    CLK    ->   D13
    MOSI   ->   D11
    MISO   ->   D12

Consider like share and subscribe : https://www.youtube.com/NematicsLab
*/


#include <SPI.h>
#include <nRF24L01.h>   //https://github.com/nRF24/RF24
#include <RF24.h>
#include <Servo.h>  
int dela;
int Mode;
const uint64_t pipeIn = 0x12345ABC;     
RF24 radio(9, 10);  //CSN and CE pins


struct Received_data {
  byte ch1;
  byte ch2;
};

Received_data received_data;

Servo channel_1;

int ch1_value = 0;
int ch2_value = 0;


void reset_the_Data() 
{
  received_data.ch1 = 128;      //Throttle (channel 1) to 0
  received_data.ch2 = 0;
}



/**************************************************/

void setup()
{
  
  channel_1.attach(5);
  dela=1552;
  
  reset_the_Data();
  Serial.begin(9600);
  
  radio.begin();
  radio.setAutoAck(false);
  radio.setDataRate(RF24_250KBPS);  
  radio.openReadingPipe(1,pipeIn);
  

  radio.startListening();

}


unsigned long lastRecvTime = 0;


void receive_the_data()
{
  while ( radio.available() ) {
  radio.read(&received_data, sizeof(Received_data));
  lastRecvTime = millis(); 
}
}


void loop()
{
  //Receive the radio data
  receive_the_data();

  unsigned long now = millis();
  if ( now - lastRecvTime > 1000 ) {
    
    reset_the_Data();

  } 
  ch2_value =received_data.ch2;
  
  if(ch2_value==0)
  {
    Mode=1;
    }
   if(ch2_value==1)
   {
    Mode = 0;
    }  
  
  //Creathe the PWM signals
  //Pro Mode
  
  if(Mode == 1)
  {
  ch1_value = map(received_data.ch1,0,255,1100,2000);
  if(dela<ch1_value && dela < 2000)
  {
  dela++;
  channel_1.writeMicroseconds(dela);
  Serial.println(dela);
  delay(10);
    }

   if(dela>ch1_value)
   {
   dela--;
  channel_1.writeMicroseconds(dela);
  Serial.println(dela);
    } 
  }

  //Noob Mode
  if(Mode==0)
  {
  ch1_value = map(received_data.ch1,0,255,1300,1820);
  

  if(dela<ch1_value && dela < 1570){
    dela++;
  channel_1.writeMicroseconds(dela);
  Serial.println(dela);
    }
    
  if(dela<ch1_value && dela < 1685){
  dela++;
  channel_1.writeMicroseconds(dela);
  Serial.println(dela);
  delay(20);
    }

  if(dela<ch1_value && dela < 1850){
  dela++;
  channel_1.writeMicroseconds(dela);
  Serial.println(dela);
  delay(12);
    } 
    
   if(dela>ch1_value){
    dela--;
  channel_1.writeMicroseconds(dela);
  Serial.println(dela);
    }
  }
  
}//Loop end
